var isMobile = {
    Android: function() {
        return navigator.userAgent.match(/Android/i);
    },
    BlackBerry: function() {
        return navigator.userAgent.match(/BlackBerry/i);
    },
    iOS: function() {
        return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    iPhone: function() {
        return navigator.userAgent.match(/iPhone/i);
    },
    Opera: function() {
        return navigator.userAgent.match(/Opera Mini/i);
    },
    Windows: function() {
        return navigator.userAgent.match(/IEMobile/i);
    },
    any: function() {
        return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows());
    }
};

var data = {
	data: null,
	gmap: false,
	detailMap: false,
	gmapStyles: [
		{
	    "featureType": "poi",
	    "elementType": "labels",
	    "stylers": [
	      { "visibility": "off" }
	    ]
	  }
	],
	markerColor:new Array(),
	markerImages: new Array(),
	markers: new Array(),
	entries: new Array(),
	tips: new Array(),
	previousPage: false,
	activePage: false,
	activeButton: false,
	activeWindow: false,
	clickEvent: 'click',
	_self: null,
	filter: false,
	origLat: false,
	origLng: false,
	locationMarker: false,
	categories: new Array(),
	startScroll: 0,
	stopScroll: 0,
	filtered: false,
	useCurrentPosition: false,
	useManualPosition: false,
	tip: false,
	touch: true,
	swipe: false,
	detailMapView: false,
	selectedMarker: false,
	mapCenter: false,
	markerPositions: [],
	orientation: 'portrait',
	watch: false,
	lat: false,
	lng: false,
	osVersion: function(){
		if (/iP(hone|od|ad)/.test(navigator.platform)) {
	    var v = (navigator.appVersion).match(/OS (\d+)_(\d+)_?(\d+)?/);
	    return parseInt(v[1], 10);
	  }
	},
	initialize: function(){
		if(this.osVersion() <= 5){
			$('.outset').css('-webkit-overflow-scrolling','scroll');
		}
		this.setFooter();
		this.setPartner();
		$(document).on('click touchstart touchend',function(e){
			//e.preventDefault();
			e.stopPropagation();
		});
		_self = this;
		window.addEventListener('orientationchange', function(){
			_self.setOrientation();
		});
		
		if(true === isMobileDevice){
			$('a[href*="http"],a[href*="https"]').on(clickEvent,function(){
				var ref = window.open($(this).attr('href'),'_blank','locations=yes');
				return false;
			});	
		}
		_self.blurActions();
		
		$.fancybox.showActivity();
		_self.markerColor['R'] = 'b70723';
		_self.markerColor['H'] = 'ca1f7b';
		_self.markerColor['C'] = 'bed000';
		_self.markerColor['K'] = 'F7B600';
		data.markerImages['Default'] = 'DefaultMarker.png';
		data.markerImages['R'] = 'RestaurantMarker.png';
		data.markerImages['K'] = 'KneipenMarker.png';
		data.markerImages['H'] = 'HotelMarker.png';
		data.markerImages['C'] = 'CafeMarker.png';
		this.setClickEvent();
		this.loadEntries();
		this.loadMap();
		this.initNavigation();
		_self.enableSwitches();
		_self.setListHeight();
		_self.setPositionText();
		$('#filter-content').on('scroll',function(e){
			if($('#filter-content').scrollLeft() > 0 || $('#filter-content').scrollRight() > 0 || $('#filter-content').scrollLeft() < 0 || $('#filter-content').scrollRight() < 0){
				$('#filter-content').css({
					'-webkit-overflow-scrolling': 'hidden',	
					'overflow' : 'hidden'
				});
				$('#filter-content').scrollLeft(0);
				$('#filter-content').scrollRight(0);
				return;
			}
			else{
				$('#filter-content').css({
					'-webkit-overflow-scrolling': 'touch',	
					'overflow' : 'auto'
				});
			}
		});
	},
	blurActions: function(){
		if($('#start').css('display') == 'block'){
			document.removeEventListener("hidekeyboard", function() {
			    $('#start-query').blur();
			}, false);
			document.addEventListener("hidekeyboard", function() {
			    $('#start-address').blur();
			}, false);
		}
		
		if($('#what').css('display') == 'block'){
			document.removeEventListener("hidekeyboard", function() {
			    $('#start-address').blur();
			}, false);
			document.addEventListener("hidekeyboard", function() {
			    $('#start-query').blur();
			}, false);
		}
	},
	setOrientation: function(){
		_self.setFooter();
		_self.setPartner();
		$('body,.page').scrollTop(0);
	},
	setFooter: function(){
		var o = window.orientation;
		var h = window.innerHeight;
		var fH = $('footer').height();
		var topPos = (h-fH);
		
		$('footer').css({
			top: topPos
		});
	},
	setPartner: function(){
		if(true === isMobileDevice){
			$('.partner a[href*="http"]').off();
			$('.partner a[href*="http"]').on(clickEvent,function(){
				var ref = window.open($(this).attr('href'),'_blank','locations=yes,width='+window.innerWidth);
				return false;
			});	
		}
		var pH = $('.partner').height();
		var wH = window.innerHeight;
		var wW = window.innerWidth;
		pTop = (wH-pH);
		$('.partner').css({
			top: (pTop+20)
		});
		var bgHeight = (wH*0.35);
			
		if(wH < wW){
			$('#start,#what').css({
				'background-size':(wH*0.25),
				'background-position': 'center 35%'
			});	
		}
		else{
			$('#start,#what').css({
				'background-size':(wH*0.35),
				'background-position': 'center 55%'
			});
		}
		
		
		var cH = $('.company').height();
		cPos2 = (pTop - cH + 10);
		
		$('.company').css({
			top: (cPos2)
		});
		if(true === isMobileDevice){
			$('a[href*="http"],a[href*="https"]').on(clickEvent,function(){
				var ref = window.open($(this).attr('href'),'_blank','locations=yes');
				return false;
			});	
		}
	},
	watchSuccess: function(position){
		_self.lat = position.coords.latitude;
		_self.lng = position.coords.longitude;
	},
	watchError: function(){
		alert('Ihre Position konnte nicht bestimmt werden');
	},
	setPositionText: function(){
		if(true !== positionAllowed){
			$('#position-text').empty().text(defaultCity);
		}
		else{
			$('#position-text').empty().text('Am aktuellen Ort');
		}
	},
	initNavigation: function(){
		//$('.outset').niceScroll();
		/*
		$('#use-current-position').on(clickEvent2,function(){
			if($('#start-query').val() != ''){
				$('#filter-query').val($('#start-query').val());
				_self.filterEntries();	
			}
			data.loadPage('map',function(){
				_self.lat = _self.origLat;
				_self.lng = _self.origLng;
				google.maps.event.trigger(data.gmap, "resize");
				data.setMyMarker();
				data.showFooter();
			});
		});*/
		
		$('#use-current-position').on(clickEvent,function(){
			_self.showActivity();
			_self.useManualPosition = false;
			_self.useCurrentPosition = true;
			//_self.lat = _self.origLat;
			//_self.lng = _self.origLng;
			_self.watch = navigator.geolocation.watchPosition(_self.watchSuccess,_self.watchError);
			/*
			$(this).closest('ul').fadeOut(function(){
				$(this).next().fadeIn();
			});*/
			_self.loadPage('what');
		});
		
		/*
		$('#start-address,#start-query').on('focus',function(){
			$(this).closest('li').find('.button:first').removeClass('no-icon');
			$(this).closest('li').find('.click-button:first').show();
		});
		*/
		
		$('#start-address').on('blur',function(){
			_self.showActivity();
			_self.useCurrentPosition = true;
			_self.useManualPosition = true;
			if(false !== _self.watch){
				navigator.geolocation.clearWatch(_self.watch);
			}
			_self.setPosition();
			_self.loadPage('what');
		});
		
		$('#start-query').on('blur',function(){
			_self.showActivity();
			if($(this).val() != ''){
				$('#filter-query').val($(this).val());
			}
			_self.filterEntries();
			_self.loadPage('list',function(){
				_self.showFooter();
			});
		});
		
		$('#use-query').on(clickEvent,function(){
			_self.showActivity();
			if($('#start-query').val() != ''){
				$('#filter-query').val($('#start-query').val());
			}
			_self.filterEntries();
			_self.loadPage('map',function(){
				google.maps.event.trigger(_self.gmap, "resize");
				_self.setMyMarker();
				_self.showFooter();
			});
		});
		
		$('#start1,#start2,#start3,#start4').on(_self.clickEvent,function(){
			_self.showActivity();
			_self.setPositionText();
			$('.start-buttons').show();
			$('.invisible').hide();
			_self.hideFooter();
			_self.loadPage('start',function(){
				_self.attachStartEvent();
			});
			_self.resetFilter();
		});
		
		$('#map0,#map1,#map2,#map3').on(_self.clickEvent,function(){
			_self.showActivity();
			_self.resetVisibility();
			_self.filterEntries();
			_self.loadPage('map',function(){
				google.maps.event.trigger(_self.gmap, "resize");
				_self.setMyMarker();
				_self.showFooter();
				$('#back-to-details').hide();
				$('#start2').show();
			});
		});
		
		$('#info1,#info2,#info3').on(_self.clickEvent,function(){
			if(true === isMobileDevice){
				$('#info a[href*="http"]').off();
				$('#info a[href*="http"]').on(clickEvent,function(){
					var ref = window.open($(this).attr('href'),'_blank','locations=yes');
					return false;
				});	
			}
			_self.showActivity();
			_self.loadPage('info',function(){
				if(true === isMobileDevice){
					$('#details a[href*="http"]').on(clickEvent,function(){
						var ref = window.open($(this).attr('href'),'_blank','locations=yes');
						return false;
					});	
				}
				//google.maps.event.trigger(_self.gmap, "resize");
				_self.hideFooter();
			});
		});
		
		
		
		$('#submit-filter').on(_self.clickEvent,function(e){
			$('.outset,.page,body').scrollTop(0);
			_self.showActivity();
			_self.filterEntries();
			_self.loadPage('list',function(){
				google.maps.event.trigger(_self.gmap, "resize");
				_self.setMyMarker();
			});
		});
		
		$('#filter0,#filter1,#filter2').on(_self.clickEvent,function(e){
			e.stopPropagation();
			_self.filterAction($(this));
		});
		
		$('#list0,#list1,#list2,#list3').on(_self.clickEvent,function(){
			_self.showActivity();
			$.fancybox.showActivity();
			_self.filterEntries();
			_self.loadPage('list',function(){
				$('.outset').scrollTop(0);
				_self.showFooter();
			});
		});
		
		/*
		$('#use-address').on(clickEvent,function(){
			if($('#start-query').val() != ''){
				$('#filter-query').val($('#start-query').val());
			}
			_self.setPosition();
		});*/
		
		$('#category').on('change',function(){
			_self.querySubCategories();
			$('body,.outset,.page').scrollTop(0);
		});
		$('#subcategory,#category').on('blur',function(){
			$('body,.outset,.page').scrollTop(0);
		});
		
		
		/*
		$('.toggle').on(clickEvent2,function(){
			$(this).toggleClass('toggle-active');
			$(this).next().toggleClass('checked');
		});
		*/
		
		$('#show-address').on(clickEvent,function(){
			_self.showDetailMap();
		});
		
		$('.back').on(_self.clickEvent2,function(){
			if(_self.previousPage){
				_self.loadPage(_self.previousPage.attr('id'));
				_self.showFooter();
			}
		});
	},
	showDetailMap: function(){
		_self.detailMapView = true;
		_self.showActivity();
		var id = $('#detail-entry').attr('data-id');
		$.each(_self.markers,function(i,marker){
			if(id != marker.id){
				marker.setVisible(false);
			}
			else{
				marker.setVisible(true);
				_self.selectedMarker = marker;
				_self.mapCenter = _self.gmap.getCenter();
				_self.gmap.setCenter(_self.selectedMarker.getPosition());
			}
		});
		if(false !== _self.selectedMarker){
			_self.loadPage('map',function(){
				google.maps.event.trigger(_self.gmap, "resize");
				_self.gmap.setCenter(_self.selectedMarker.getPosition());
				_self.showFooter();
				$('#start2').hide();
				$('#back-to-details').show();
			});	
		}
	},
	resetVisibility: function(){
		if(false !== _self.selectedMarker){
			$.each(_self.markers,function(i,marker){
				if(true !== marker.getVisible()){
					marker.setVisible(true);
				}
			});
			_self.selectedMarker = false;
			_self.gmap.setCenter(_self.mapCenter);
			_self.mapCenter = false;
		}
	},
	filterAction: function(el){
		var txt = el.find('span:first');
		if(false !== _self.filter && _self.activePage.attr('id') == 'filter'){
			if(txt.text() == 'Clear'){
				txt.text('Filter');
				_self.resetFilter();
			}
		}
		else{
			_self.showActivity();
			_self.filterEntries();
			_self.loadPage('filter',function(){
				google.maps.event.trigger(_self.gmap, "resize");
				_self.setMyMarker();
			});
		}
	},
	enableSwitches: function(){
		$('.toggle').swipe({
			swipe: function(e,direction,distance,duration){
				var div = $(this);
				switch(direction){
					case 'left':
					div.removeClass('toggle-active');
					div.next().removeClass('checked');
					break;
					
					default:
					div.addClass('toggle-active');
					div.next().addClass('checked');
					break;
				}
			},
			threshold: 0
		});
	},
	setListHeight: function(){
		var wH = $(window).height();
		var fH = $('footer').height();
		var hH = $('header').height();
		var h = (wH - fH - hH);
		$('#entry-list').css('height',h);
		$('#filter-content').css('height',h);
	},
	attachStartEvent: function(){
		
	},
	setFilter: function(){
		var f = new Array();
		_self.query = $('#filter-query').val();
		if(_self.query != ''){
			var parts = _self.query.split(' ');
			$.each(parts,function(i,str){
				if(str != '' && str != ' '){
					f.push(str);
				}
			});
		}
		var cat = $('#category').val();
		var subcat = $('#subcategory').val();
		if(cat != 0){
			f.push($('#category option:selected').text());
		}
		if(subcat != 0){
			f.push($('#subcategory option:selected').text());
		}
		$.each($('.checked'),function(i){
			str = $(this).val();
			if(str != '' && str != ' '){
				f.push(str);
			}
		});
		var cleaned = new Array();
		$.each(f,function(i,str){
			if(str != '' && str != ' '){
				cleaned.push(str);
			}
		});
		f = cleaned;
		
		if(f.length > 0){
			_self.filtered = true;
			return f;
		}
		return false;
	},
	enableListLinks: function(){
		$('[rel="details"]').on(clickEvent,function(){
			$.fancybox.showActivity();
			var id = $(this).attr('data-id');
			_self.hideFooter();
			_self.showDetails(id);
		});
	},
	disableListLinks: function(){
		$('[rel="details"]').off();
	},
	showDetails: function(id){
		_self.hideFooter();
		_self.closeActiveInfoWindow();
		var container = $('#detailContainer');
		container.empty();
		$.ajax({
			url: baseUrl+'details.json?entry='+id,
			cache: false,
			dataType: 'jsonp',
			data: {magazine: magazine},
			jsonpCallback: "collectData",
			success: function(result){
				var html = result.data;
				container.html(html);
				container.append('<div class="bottom-spacer">&nbsp;</div>');
				_self.loadPage('details',function(){
					$.fancybox.hideActivity();
					if(true === isMobileDevice){
						$('#details a[href*="http"]:not([href*="'+imagePath+'"])').on(clickEvent,function(){
							var ref = window.open($(this).attr('href'),'_blank','locations=yes');
							return false;
						});	
					}
					if($('#gallery img').length > 0){
						var gallery = $("#gallery a").photoSwipe({ enableMouseWheel: false , enableKeyboard: false });
					}
				});
			}
		});
	},
	queryCategories: function(){
		
		
	},
	querySubCategories: function(){
		var parts = $('#category').val().split(':');
		var parent = parts[1];
		
		var categories = _self.data.categories[parent];
		if(categories){
			$('#subcategory').html('');
			if(categories.length == 0){
				$('#subcategory-container').hide();
				return false;
			}
			$('#subcategory').append('<option value="0">alle Angebote</option>');
			
			$.each(categories,function(i,entry){
				if(entry.label != '.' && entry.label != ','){
					$('<option value="'+entry.label+':'+entry.id+'">'+entry.label+'</option>').appendTo('#subcategory');
				}
			});
			$('#subcategory-container').fadeIn(function(){
				//$('subcategory').focus();
			});	
		}
		else{
			$('#subcategory-container').hide();
		}
	},
	categorySuccess: function(tx,result){
		$('#category').html('');
		$('#category').append('<option value="0">alle Restaurants, Lokale</option>');
		if(!result.rowsAffected && result.rows.length == 0){
			return false;
		}
		var len = result.rows.length;
		for(var i=0;i<len;i++){
			//_self.categories[result.rows.item(i).id].push(result.rows.item(i));
			var entry = result.rows.item(i);
			if(entry.label != '.' && entry.label != ','){
				$('<option value="'+entry.label+':'+entry.id+'">'+entry.label+'</option>').appendTo('#category');	
			}
		}
	},
	subCategorySuccess: function(tx,result){
		$('#subcategory').html('');
		if(!result.rowsAffected && result.rows.length == 0){
			$('#subcategory-container').hide();
			return false;
		}
		$('#subcategory').append('<option value="0">alle</option>');
		var len = result.rows.length;
		if(len == 0){
			$('#subcategory-container').hide();
		}
		for(var i=0;i<len;i++){
			var entry = result.rows.item(i);
			if(entry.label != '.' && entry.label != ','){
				$('<option value="'+entry.label+':'+entry.id+'">'+entry.label+'</option>').appendTo('#subcategory');
			}
		}
		//$('#subcategory')[0].selectedIndex = 1;
		$('#subcategory-container').fadeIn(function(){
			//$('#subcategory').focus();
		});
		//$('#subcategory').focus();
	},
	setPosition: function(){
		_self.address = $('#start-address').val();
		_self.address += ','+defaultCity+',Nordrhein-Westfalen';
		
		var geocoder = new google.maps.Geocoder();
		geocoder.geocode({'address': _self.address},function(results,status){
			if(status = google.maps.GeocoderStatus.OK){
				pos = results[0].geometry.location;
				if(pos.lat() != _self.lat && pos.lng() != _self.lng){
					_self.deleteMarkers();
					$('#entries').empty();
					_self.loadEntries();
				}
				_self.lat = pos.lat();
				_self.lng = pos.lng();
				_self.setMyMarker();
				/*
				_self.showFooter();
				_self.loadPage('map',function(){
					google.maps.event.trigger(data.gmap, "resize");
					_self.setMyMarker();			
				});*/
			}
			else{
				alert('Geocoding error');
			}
		});
	},
	geoSuccess: function(position){
		_self.lat = position.coords.latitude;
		_self.lng = position.coords.longitude;
		_self.loadPage('map',function(){
			google.maps.event.trigger(data.gmap, "resize");
			data.setMyMarker();
			data.showFooter();
		});
	},
	geoError: function(error){
		alert('Fehler: '+error.code+', Meldung: '+error.message);
	},
	filterEntries: function(){
		_self.filter = _self.setFilter();
		if(false != _self.filter){
			var resultRows = new Array();
			$.each(_self.data.entries,function(i,entry){
				if(_self.filterMatch(entry.filter)){
					resultRows.push(entry);
				}
			});
			_self.setResult(resultRows);
		}
		else{
			if(_self.filtered){
				_self.filtered = false;
				_self.setResult(_self.data.entries);
			}	
		}
	},
	filterMatch: function(filterString){
		for(var i = 0; i < _self.filter.length; i++){
			var regex = new RegExp(_self.filter[i],'i');
			if(filterString.match(regex) <= 0){
				return false;
			}
		}
		return true;
	},
	resetFilter: function(){
		$('.search').val('');
		$('.toggle').removeClass('toggle-active');
		$('.toggle').next().removeClass('checked');
		$('#categories option').removeAttr('selected');
		$('#categories option:first').attr('selected','selected');
		$('#subcategory').empty();
		$('#subcategory-container').fadeOut();
		//$('#start-query').addClass('no-icon').removeClass('clear-input');
		_self.filter = false;
		$('#start-query').closest('div').removeClass('clear-input');
		$('#entries').empty();
		//_self.loadEntries();
		data.resetList();
		_self.gmap.setCenter(origin);
		_self.gmap.setZoom(zoomLevel);
	},
	resetMarkers: function(){
		$.each(_self.markers,function(i,marker){
			marker.setMap(_self.gmap);
		});
	},
	resetList: function(){
		$('.list-item').show();
	},
	showFooter: function(callback,options){
		$('footer').show(function(){
			options = (options != undefined && typeof options == 'object' ? options : null);
			if(callback != undefined && typeof callback == 'function') callback(options);
		});
	},
	hideFooter: function(){
		$('footer').hide();
	},
	setClickEvent: function(){
		if ('ontouchend' in document.documentElement) {
			this.clickEvent = 'touchstart';
		}
		if ('ontouchmove' in document.documentElement) {
			_self.touch = true;
		}
		if ('ontouchstart' in document.documentElement) {
			this.clickEvent2 = 'touchstart';
		}
		else{
			this.clickEvent2 = clickEvent;
		}
	},
	loadPage: function(page,callback,options){
		if(_self.activePage && _self.activePage.attr('id') != 'list'){
			$('.outset').scrollTop(0);	
		}
		if(false !== _self.filter && page == 'filter'){
			$('.filter').find('span:first').text('Clear');
		}
		else{
			$('.filter').find('span:first').text('Filter');
		}
		$('.page').scrollTop(0);
		$('body').scrollTop(0);
		_self.previousPage = $('.page:visible');
		_self.activePage = $('#'+page);
		_self.setActiveButton(page);
		//_self.previousPage.removeClass('visible').addClass('hidden');
		_self.previousPage.hide();
		//_self.activePage.removeClass('hidden').addClass('visible');
		_self.setFooter();
		_self.activePage.fadeIn(function(){
			if(true === isMobileDevice){
				$('a[href*="http"],a[href*="https"]').unbind().on(clickEvent,function(){
					var ref = window.open($(this).attr('href'),'_blank','locations=yes');
					return false;
				});	
			}
			_self.hideActivity();
			_self.blurActions();
			if(page == 'filter'){
				_self.showFooter();
				//$('#category').focus();
			}
			else{
				//$('#category').blur();
			}
			if(page == 'start' || page == 'what'){
				_self.hideFooter();
				//$('#category').focus();
			}
			
		});
		/*
		_self.previousPage.fadeOut();
		_self.activePage.fadeIn(function(){
			if(page == 'filter'){
				_self.showFooter(function(){
					$('#category').focus();
				});
			}
		});*/
		options = (options != undefined && typeof options == 'object' ? options : null);
		if(callback != undefined && typeof callback == 'function') callback(options);
	},
	showCategories: function(){
		
	},
	showActivity: function(){
		$.fancybox.showActivity();
	},
	hideActivity: function(){
		$.fancybox.hideActivity();
	},
	setActiveButton: function(className){
		if(_self.activeButton){
			_self.activeButton.removeClass('active');
		}
		_self.activeButton = $('footer .'+className);
		if(_self.activeButton.length > 0){
			_self.activeButton.addClass('active');
		}
	},
	loadEntries: function (){
		$.ajax({
			url: baseUrl+'data.json',
			cache: false,
			dataType: 'jsonp',
			data: {magazine: magazine},
			jsonpCallback: "collectData",
			success: function(httpResult){
				_self.data = httpResult;
				_self.setResult(httpResult.entries);
				_self.setCategories();
				_self.populatePartner();
				navigator.splashscreen.hide();
			}
		});
	},
	populatePartner: function(){
		if(null != _self.data.partner){
			$('.partner-logo').empty().html('<a href="'+unescape(_self.data.partner.url)+'" title="'+_self.data.partner.label+'"><img src="'+baseUrl+'data/partner/'+_self.data.partner.image+'" alt="Partner Logo"></a>');
			_self.setPartner();
		}
		else{
			$('.partner').hide();
		}
	},
	setOrigin: function(){
		if(!_self.lat && !_self.lng){
			_self.lat = defaultLat;
			_self.lng = defaultLng;
		}
		
		_self.origLat = _self.lat;
		_self.origLng = _self.lng;
	},
	loadMap: function(){
		this.setOrigin();
		var styledMap = new google.maps.StyledMapType(_self.gmapStyles,{name: "Styled Map"});
		var mapOptions = {
			zoom: zoomLevel,
			disableDefaultUI: true,
			center: new google.maps.LatLng(this.lat,this.lng),
			mapTypeControlOptions: {
		      mapTypeIds: [google.maps.MapTypeId.ROADMAP, 'map_style']
		   }
		};
	  	this.gmap = new google.maps.Map(document.getElementById('google'),mapOptions);
	  	this.gmap.mapTypes.set('map_style', styledMap);
  		this.gmap.setMapTypeId('map_style');
	  	//google.maps.event.addListener(data.gmap, 'zoom_changed', data.refreshMarkers);
	  	//google.maps.event.addListener(_self.gmap, 'idle', _self.selectMarkers);
	  	google.maps.event.addListener(data.gmap, 'click', data.closeActiveInfoWindow);
	  	this.setMyMarker();
	},
	selectMarkers: function(){
		/*
		var bounds = _self.gmap.getBound();
		$.each(_self.markers,function(i,marker){
			if(!bounds.contains(new google.maps.LatLng(marker.lat, marker.lng))){
				marker.setMap(null);
			}
			else{
				marker.setMap(_self.gmap);
			}
		});*/
	},
	closeActiveInfoWindow: function(){
		if(data.activeWindow){
			data.activeWindow.close();
		}
	},
	setMyMarker: function(){
		if(_self.locationMarker){
			_self.locationMarker.setMap(null);
		}
		var origin = new google.maps.LatLng(_self.lat,_self.lng);
		var image = new google.maps.MarkerImage(
			myLocationIcon,
			new google.maps.Size( 17, 17 ), // size
			null, // origin
			new google.maps.Point( 0, 0 ),
				new google.maps.Size( 17, 17 ) // scaled size (required for Retina display icon)
			);

			_self.locationMarker = new google.maps.Marker({
			flat: true,
			icon: image,
			map: _self.gmap,
			optimized: false,
			position: origin,
			title: 'Meine Position',
			visible: true
		});
		/*
		_self.locationMarker = new google.maps.Marker({
			position: origin,
			icon: image,
			flat: true,
			map: _self.gmap,
			title: 'Meine Position',
			optimized: false,
			visible:true	
		});*/
		_self.gmap.setCenter(origin);
		_self.gmap.setZoom(zoomLevel);
		if(false !== _self.filter){
			data.sortMarkers();
			var latlngbounds = new google.maps.LatLngBounds();
			var c = 0;
			$.each(data.markers,function(n,marker){
				if(c < 10){
					latlngbounds.extend(marker.position);	
				}
				c = (c+1);
			});
			_self.gmap.setCenter(origin);
			//_self.gmap.setCenter(latlngbounds.getCenter());
			_self.gmap.fitBounds(latlngbounds);
		}
		else{
			_self.markerPositions = [];
		}
	},
	querySelect: function(tx){
		var params = new Array(); var count = 0;
		$.each(_self.filter,function(i,str){
			if(str.length > 1){
				params[count] = "LIKE '%"+str+"%'";
				count = (count+1);	
			}
		});
		var params = params.join(' AND filter ');
		var sql = "SELECT * FROM entries WHERE filter "+params;
		tx.executeSql(sql,[],_self.selectSuccess,_self.queryError);
	},
	selectSuccess: function(tx,result){
		_self.setResult(result.rows);
		//_self.refreshList(result.rows);
	},
	filterSuccess: function(tx,result){
		_self.setResult(result.rows);
	},
	deleteMarkers: function(){
		$.each(_self.markers,function(i,marker){
			marker.setMap(null);
		});
	},
	queryAll: function(tx){
		tx.executeSql("SELECT * FROM entries",[],_self.loadSuccess,_self.noData);
	},
	markerQuery: function(tx){
		tx.executeSql("SELECT * FROM entries",[],_self.markerQuerySuccess,_self.queryError);
	},
	markerQuerySuccess: function(tx,result){
		data.setMarkers(result.rows);
	},
	refreshMarkers: function(){
		data.closeActiveInfoWindow();
		
		
		/*
		var bounds = data.gmap.getBounds();
		$.each(data.markers,function(i,marker){
			if(!bounds.contains(marker.getPosition())){
				marker.setMap(null);
			}
			else{
				marker.setMap(data.gmap);
			}
		});*/
	},
	refreshList: function(){
		
	},
	noData: function(){
		var db = window.openDatabase('tips','1.0','Geht aus App',500000);
		$.ajax({
			url: baseUrl+'data.json',
			cache: false,
			dataType: 'jsonp',
			data: {magazine: 11},
			jsonpCallback: "collectData",
			success: function(httpResult){
				content = httpResult;
				db.transaction(data.populateDB,data.queryError,data.querySuccess);
			}
		});
	},
	setResult: function(rows){
		_self.deleteMarkers();
		$('#entries').empty();
		_self.markers = new Array();
		_self.entries = new Array();
		_self.tips = new Array();
		$.each(rows,function(i,row){
			data.addEntry(row);
		});
		//data.refreshMarkers();
		data.sortTips();
		data.setTips();
		data.sortList();
		data.setList();
		if(rows.length == 0){
			_self.noResults();
		}
		if($('.page:visible').attr('id') == 'splash'){
			_self.loadPage('start',function(){
				_self.attachStartEvent();
			});
		}
		$.fancybox.hideActivity();
	},
	noResults: function(){
		$('#entries').append('<li class="list-item disabled"><span class="valign list-image">&nbsp</span><h3>Es konnten keine Einträge gefunden werden.</h3></li>');
	},
	setCategories: function(){
		$('#category').html('');
		$('#category').append('<option value="0">alle Restaurants, Lokale</option>');
		$.each(_self.data.categories[0],function(i,entry){
			if(entry.label != '.' && entry.label != ','){
				$('<option value="'+entry.label+':'+entry.id+'">'+entry.label+'</option>').appendTo('#category');	
			}
		});
	},
	sortList: function(){
		data.entries = data.entries.sort(function(a,b){
			if(a.key < b.key){
				return -1;
			}
			if(a.key > b.key){
				return 1;
			}
			return 0;
		});
	},
	sortTips: function(){
		data.tips = data.tips.sort(function(a,b){
			if(a.key < b.key){
				return -1;
			}
			if(a.key > b.key){
				return 1;
			}
			return 0;
		});
	},
	sortMarkers: function(){
		data.markers = data.markers.sort(function(a,b){
			if(a.distance < b.distance){
				return -1;
			}
			if(a.distance > b.distance){
				return 1;
			}
			return 0;
		});
	},
	setTips: function(){
		if(data.tips.length > 0){
			var tip = data.tips[0].val;
			_self.tip = tip;
			var html = '<li data-id="'+tip.id+'" class="tip-item" rel="details">';
			html += '<span class="valign list-image">';
			if(tip.thumb != null){
				var image = tip.thumb;
				html += '<img src="'+imagePath+'/thumbnail/?__file='+escape(tip.id+'/'+image)+'&__w=200" alt="Ansicht">';
			}
			else{
				html += '<img src="img/no-thumb.png" alt="Ansicht">';
			}
			html += '</span>';
			html += '<h3 title="'+tip.label+'">'+tip.label+'</h3>';
			html += '<p>';
			html += tip.categoryString;
			
			html +='</p>';
			//html += '<img id="tip-image" src="img/tipp-64-r.png">';
			//html += '<span class="distance tip-teaser">'+tip.distance+'</span>';
			html += '<div class="tip-highlight"><img src="img/tipp.png" alt="TIPP"><br><span class="tip-distance">'+tip.distance+'</span></div>';
			html += '</li>';
			$('#entries').prepend(html);
		}
	},
	setList: function(){
		$.each(data.entries,function(i,entry){
			if(false === _self.tip || entry.val.id != _self.tip.id){
				var html = '<li class="list-item" id="li'+entry.val.id+'" data-id="'+entry.val.id+'" rel="details">';
				html += '<span class="valign list-image">';
				
				if(entry.val.thumb != null){
					var image = entry.val.thumb;
					html += '<img src="'+imagePath+'/thumbnail/?__file='+escape(entry.val.id+'/'+image)+'&__w=200" alt="Ansicht">';
					//html += '<img src="'+imagePath+'/'+escape(entry.val.id+'/'+image.replace('t_',''))+'" alt="Ansicht">';
				}
				else{
					html += '<img src="img/no-thumb.png" alt="Ansicht">';
				}
				
				html += '</span>';
				//html += '<img src="img/gmap-dummy.png" alt="Ansicht">';
				//html += '<div class="fl list-item-text">';
				html += '<h3 title="'+entry.val.label+'">'+entry.val.label+'</h3>';
				html += '<p>';
				html += entry.val.categoryString;
				html +='</p>';
				//html += '</div>';
				//html += '<span class="distance">'+entry.val.distance+'</span>';
				if(entry.val.premium == 1){
					html += '<div class="tip-highlight"><img src="img/premium.png" alt="TIPP"><br><span class="premium-distance">'+entry.val.distance+'</span></div>';	
				}
				else{
					html += '<div class="list-highlight"><span class="list-distance">'+entry.val.distance+'</span></div>';
				}
				html += '</li>';
				//var html = '<li class="list-item">'+entry.val.filter+'</li>';
				$('#entries').append(html);	
			}
		});
		_self.enableListLinks();
	},
	rad: function(x) {
		return x*Math.PI/180;
	},
	getDistance: function(mlat,mlng){
		var R = 6371; // earth's mean radius in km
		
		orgLng = _self.lng;
		orgLat = _self.lat;
		
		var dLat  = _self.rad(mlat - orgLat);
	  	var dLong = _self.rad(mlng - orgLng);
		
		var a = Math.sin(dLat/2) * Math.sin(dLat/2) + Math.cos(_self.rad(orgLat)) * Math.cos(_self.rad(mlat)) * Math.sin(dLong/2) * Math.sin(dLong/2);
		var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
		var d = R * c;
		
		return d.toFixed(3);
	},
	addEntry: function(marker){
		var distance = this.getDistance(marker.lat,marker.lng);
		var disTest = Math.round(distance*10)/10;
		
		if(disTest < 20 && parseFloat(distance)){
			var numeric = parseFloat(distance);
			if(distance < 1){
				distance = Math.round(distance*1000)+' m';	
			}
			else{
				distance = Math.round(distance*10)/10+' km';
			}
			var categoryString = '';
			var contentString = '<div class="gmap-window"><h4 title="'+unescape(marker.label)+'" data-id="'+marker.id+'" onclick="data.showDetails('+marker.id+')">'+unescape(marker.label)+'</h4>';
			contentString += '<p class="categories">';
			if(marker.categoryString){
				contentString += marker.categoryString;	
			}
			marker.distance = distance;
			marker.numeric = numeric;
			contentString += ', <span class="marker-distance">'+marker.distance+'</span>';
			contentString +='</p>';
			contentString += '<p><span class="show-details detail-icon" data-id="'+marker.id+'" data-id="'+marker.id+'" onclick="data.showActivity(); data.showDetails('+marker.id+')">Details anzeigen &raquo;</span></p>';
			contentString += '</div>';
			
			var entryType = 'Default';
			if(marker.categoryString){
				entryType = escape(marker.categoryString.substring(0,1));
			}
			
			var markerImage = 'DefaultMarker.png';
			if(data.markerImages[entryType]){
				markerImage = data.markerImages[entryType];
			}
			/*
			if(_self.markerColor[entryType]){
				markerColor = _self.markerColor[entryType];
			}*/
			var markerColor = 'bed000';
			var markerPosition = new google.maps.LatLng(marker.lat,marker.lng);
			
			/*
			if(marker.premium == 'true'){
				var mark = new google.maps.Marker({
					map: _self.gmap,
					icon: gmapPremiumIcon,
					position: markerPosition,
					zIndex: 100000,
					id: marker.id
				});
			}
			else{
				var mark = new StyledMarker({id: marker.id, styleIcon:new StyledIcon(StyledIconTypes.BUBBLE,{fore: 'ffffff',color:markerColor,text:entryType}),position:markerPosition,map:_self.gmap});	
			}*/
			
			//var mark = new StyledMarker({id: marker.id, styleIcon:new StyledIcon(StyledIconTypes.BUBBLE,{fore: 'ffffff',color:markerColor,text:entryType}),position:markerPosition,map:_self.gmap});
			
			
			var mark = new google.maps.Marker({
				id: marker.id,
				'distance' : numeric,
	        	position: markerPosition,
	        	map: data.gmap,
	        	icon: 'img/'+markerImage
	        });
			
			var infoWindow = new google.maps.InfoWindow({
				content: contentString,
				maxWidth: 250
			});
			
			google.maps.event.addListener(mark,'click',function(){
				if(data.activeWindow){
					data.activeWindow.close();
				}
				infoWindow.open(data.gmap,mark);
				data.activeWindow = infoWindow;
			});
			
			data.markers.push(mark);
			//_self.markerPositions.push(markerPosition);
			data.entries.push({'key' : marker.numeric, 'val' : marker});
			if(marker.premium == true){
				data.tips.push({'key' : marker.numeric, 'val' : marker});	
			}
		}
		else{
			/*
			if(distance < 1){
				distance = Math.round(distance*1000)+' m';	
			}
			else{
				distance = Math.round(distance*10)/10+' km';
			}
			alert(marker.label+' '+distance);*/
		}
	},
	queryError: function(error){
		if(error.code){
			$.fancybox('queryError: '+error.code+'. Info: '+error.message);	
		}
		else{
			//alert('Fehler');
		}
	}
};

$(document).ready(function(){
	data.initialize();
});

